Package biotransformer.btransformers

## Class HGutBTransformer

- java.lang.Object
- - biotransformer.btransformers.Biotransformer
  - - biotransformer.btransformers.HGutBTransformer

    public class HGutBTransformer
    extends Biotransformer

### Field Summary

### Fields inherited from class biotransformer.btransformers.Biotransformer

`bSystem, enzymesByreactionGroups, enzymesList, inchiGenFactory, mapper, reactionsByGroups, reactionsHash, smiGen`

### Constructor Summary

Constructors
`HGutBTransformer()`

### Method Summary

All Methods Instance Methods Concrete Methods
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialConjugations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialConjugations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialConjugationsChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialConjugationsChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialDeconjugations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialDeconjugations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialDeconjugationsChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialDeconjugationsChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialMetabolismHydrolysisAndRedoxChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialMetabolismHydrolysisAndRedoxChain​(org.openscience.cdk.interfaces.IAtomContainerSet targets, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialMetabolismHydrolysisAndRedoxStep​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialMetabolismHydrolysisAndRedoxStep​(org.openscience.cdk.interfaces.IAtomContainerSet targets, boolean preprocess, boolean filter, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialRedoxChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialRedoxReactions​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialRedoxReactions​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyGutMicrobialRedoxReactionsChain​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int nr_of_steps)`
`java.util.LinkedHashMap<java.lang.String,​java.util.ArrayList<MetabolicReaction>>` `getReactionsList()` returns a linked hash map with the reactions associated with the human gut, in addition to standardization reactions.
`boolean` `isConjugationCandidate​(org.openscience.cdk.interfaces.IAtomContainer molecule)`
`boolean` `isDeconjugationCandidate​(org.openscience.cdk.interfaces.IAtomContainer molecule)`
`void` `printStatistics()`
`java.util.ArrayList<Biotransformation>` `simulateGutMicrobialMetabolism​(java.lang.String targetsFileNameInSDF, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `simulateGutMicrobialMetabolism​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int numberOfSteps)`
`java.util.ArrayList<Biotransformation>` `simulateGutMicrobialMetabolism​(org.openscience.cdk.interfaces.IAtomContainer target, boolean preprocess, boolean filter, int numberOfSteps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `simulateGutMicrobialMetabolism​(org.openscience.cdk.interfaces.IAtomContainerSet targets, boolean preprocess, boolean filter, int numberOfSteps)`
`java.util.ArrayList<Biotransformation>` `simulateGutMicrobialMetabolism​(org.openscience.cdk.interfaces.IAtomContainerSet targets, boolean preprocess, boolean filter, int numberOfSteps, java.lang.Double scoreThreshold)`
`void` `simulateGutMicrobialMetabolismAndSave​(java.lang.String targetsFileNameInSDF, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold, java.lang.String metabolitesFileNameInSDF)`
`void` `simulateGutMicrobialMetabolismAndSave​(java.lang.String targetsFileNameInSDF, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold, java.lang.String metabolitesFileNameInSDF, boolean annotate)`
`void` `simulateGutMicrobialMetabolismAndSaveToSDF​(org.openscience.cdk.interfaces.IAtomContainerSet containers, int nrOfSteps, java.lang.Double scoreThreshold, java.lang.String outputFolder)`
`void` `simulateGutMicrobialMetabolismAndSaveToSDF​(org.openscience.cdk.interfaces.IAtomContainerSet containers, int nrOfSteps, java.lang.Double scoreThreshold, java.lang.String outputFolder, boolean annotate)`

### Methods inherited from class biotransformer.btransformers.Biotransformer

`applyPathwaySpecificBiotransformationChain, applyPathwaySpecificBiotransformations, applyPathwaySpecificBiotransformations, applyPathwaySpecificBiotransformationsChain, applyPathwaySpecificBiotransformationsChain, applyReactionAndReturnBiotransformations, applyReactionAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionChain, applyReactionChain, applyReactions, applyReactions, applyReactionsAndReturnBiotransformations, applyReactionsAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsFromContainersAndReturnBiotransformations, extractProductsFromBiotransformations, extractProductsFromBiotransformationsWithTransformationData, extractProductsFromBiotransformationsWithTransformationData, extractProductsFromBiotransformationsWithTransformationData, extractProductsFromBiotransformationsWithTransformationData, generateAllMetabolitesFromAtomContainer, generateAllMetabolitesFromAtomContainer, generateAllMetabolitesFromAtomContainerViaTransformationAtAllLocations, getBioSystemName, getSmiParser, isValidSubstrate, metabolizeWithEnzyme, metabolizeWithEnzyme, metabolizeWithEnzyme, metabolizeWithEnzyme, metabolizeWithEnzymes, metabolizeWithEnzymes, metabolizeWithEnzymesBreadthFirst, metabolizeWithEnzymesBreadthFirst, metabolizeWithEnzymesDephtFirst, saveBioTransformationProductsToCSV, saveBioTransformationProductsToCSV, saveBioTransformationProductsToCSV, saveBioTransformationProductsToCSV, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSDF`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### HGutBTransformer

    public HGutBTransformer()
                     throws java.io.IOException,
                            org.openscience.cdk.exception.CDKException

Throws:
  `java.io.IOException`
  `org.openscience.cdk.exception.CDKException`

### Method Detail

#### getReactionsList

    public java.util.LinkedHashMap<java.lang.String,​java.util.ArrayList<MetabolicReaction>> getReactionsList()

returns a linked hash map with the reactions associated with the human gut, in addition to standardization reactions.

Overrides:
  `getReactionsList` in class `Biotransformer`

#### applyGutMicrobialDeconjugations

    public java.util.ArrayList<Biotransformation> applyGutMicrobialDeconjugations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                  boolean preprocess,
                                                                                  boolean filter)
                                                                           throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
Returns:
  an arraylist of biotransformations, which are instances of the human gut microbial reactions applied to the target, with a threshold of 0.0
Throws:
  `java.lang.Exception` - - throw any exception

#### applyGutMicrobialDeconjugations

    public java.util.ArrayList<Biotransformation> applyGutMicrobialDeconjugations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                  boolean preprocess,
                                                                                  boolean filter,
                                                                                  double scoreThreshold)
                                                                           throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
Returns:
  an arraylist of biotransformations, which are instances of the human gut microbial reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception` - - throw any exception

#### applyGutMicrobialDeconjugationsChain

    public java.util.ArrayList<Biotransformation> applyGutMicrobialDeconjugationsChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                       boolean preprocess,
                                                                                       boolean filter,
                                                                                       int nr_of_steps)
                                                                                throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nr_of_steps` - - number of steps
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the human gut microbial metabolic reactions applied to the target, with the minimum threshold of 0.0
Throws:
  `java.lang.Exception` - - throw any exception

#### applyGutMicrobialDeconjugationsChain

    public java.util.ArrayList<Biotransformation> applyGutMicrobialDeconjugationsChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                       boolean preprocess,
                                                                                       boolean filter,
                                                                                       int nr_of_steps,
                                                                                       java.lang.Double scoreThreshold)
                                                                                throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nr_of_steps` - - number of steps
  `scoreThreshold` - - The minimum score for a reaction
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the human gut microbial metabolic reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception`

#### applyGutMicrobialRedoxReactions

    public java.util.ArrayList<Biotransformation> applyGutMicrobialRedoxReactions​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                  boolean preprocess,
                                                                                  boolean filter)
                                                                           throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
Returns:
  an arraylist of biotransformations, which are instances of the human gut microbial reactions applied to the target, with a threshold of 0.0
Throws:
  `java.lang.Exception`

#### applyGutMicrobialRedoxReactions

    public java.util.ArrayList<Biotransformation> applyGutMicrobialRedoxReactions​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                  boolean preprocess,
                                                                                  boolean filter,
                                                                                  double scoreThreshold)
                                                                           throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `scoreThreshold` - - minimum threshold for reaction scores
Returns:
  an arraylist of biotransformations, which are instances of the human gut microbial reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception` - - throw any exception

#### applyGutMicrobialRedoxReactionsChain

    public java.util.ArrayList<Biotransformation> applyGutMicrobialRedoxReactionsChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                       boolean preprocess,
                                                                                       boolean filter,
                                                                                       int nr_of_steps)
                                                                                throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nr_of_steps` - - number of steps
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the human gut microbial metabolic reactions applied to the target, with the minimum threshold of 0.0
Throws:
  `java.lang.Exception` - - throw any exception

#### applyGutMicrobialRedoxChain

    public java.util.ArrayList<Biotransformation> applyGutMicrobialRedoxChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                              boolean preprocess,
                                                                              boolean filter,
                                                                              int nr_of_steps,
                                                                              java.lang.Double scoreThreshold)
                                                                       throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
  `nr_of_steps` - - number of steps
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the human gut microbial metabolic reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception` - -throw any exception

#### applyGutMicrobialConjugations

    public java.util.ArrayList<Biotransformation> applyGutMicrobialConjugations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                boolean preprocess,
                                                                                boolean filter)
                                                                         throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
Returns:
  an arraylist of biotransformations, which are instances of the human gut microbial reactions applied to the target, with a threshold of 0.0
Throws:
  `java.lang.Exception` - - throw any exception

#### applyGutMicrobialConjugations

    public java.util.ArrayList<Biotransformation> applyGutMicrobialConjugations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                boolean preprocess,
                                                                                boolean filter,
                                                                                double scoreThreshold)
                                                                         throws java.lang.Exception

Parameters:
  `target` - - The molecule to transform
  `preprocess` - - specify whether to perform molecule preprocessing
  `filter` - - apply reaction filtering
Returns:
  an arraylist of biotransformations, which are instances of the human gut microbial reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception` - - throw any exception

#### applyGutMicrobialConjugationsChain

    public java.util.ArrayList<Biotransformation> applyGutMicrobialConjugationsChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                     boolean preprocess,
                                                                                     boolean filter,
                                                                                     int nr_of_steps)
                                                                              throws java.lang.Exception

Parameters:
  `target` -
  `preprocess` -
  `filter` -
  `nr_of_steps` -
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the human gut microbial metabolic reactions applied to the target, with the minimum threshold of 0.0
Throws:
  `java.lang.Exception`

#### applyGutMicrobialConjugationsChain

    public java.util.ArrayList<Biotransformation> applyGutMicrobialConjugationsChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                     boolean preprocess,
                                                                                     boolean filter,
                                                                                     int nr_of_steps,
                                                                                     java.lang.Double scoreThreshold)
                                                                              throws java.lang.Exception

Parameters:
  `target` -
  `preprocess` -
  `filter` -
  `nr_of_steps` -
Returns:
  an arraylist of biotransformations obtained after the specified number of steps (nr_of_steps), which are instances of the human gut microbial metabolic reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception`

#### applyGutMicrobialMetabolismHydrolysisAndRedoxStep

    public java.util.ArrayList<Biotransformation> applyGutMicrobialMetabolismHydrolysisAndRedoxStep​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                                    boolean preprocess,
                                                                                                    boolean filter,
                                                                                                    java.lang.Double scoreThreshold)
                                                                                             throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### applyGutMicrobialMetabolismHydrolysisAndRedoxStep

    public java.util.ArrayList<Biotransformation> applyGutMicrobialMetabolismHydrolysisAndRedoxStep​(org.openscience.cdk.interfaces.IAtomContainerSet targets,
                                                                                                    boolean preprocess,
                                                                                                    boolean filter,
                                                                                                    java.lang.Double scoreThreshold)
                                                                                             throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### applyGutMicrobialMetabolismHydrolysisAndRedoxChain

    public java.util.ArrayList<Biotransformation> applyGutMicrobialMetabolismHydrolysisAndRedoxChain​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                                     boolean preprocess,
                                                                                                     boolean filter,
                                                                                                     int nr_of_steps,
                                                                                                     java.lang.Double scoreThreshold)
                                                                                              throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### applyGutMicrobialMetabolismHydrolysisAndRedoxChain

    public java.util.ArrayList<Biotransformation> applyGutMicrobialMetabolismHydrolysisAndRedoxChain​(org.openscience.cdk.interfaces.IAtomContainerSet targets,
                                                                                                     boolean preprocess,
                                                                                                     boolean filter,
                                                                                                     int nr_of_steps,
                                                                                                     java.lang.Double scoreThreshold)
                                                                                              throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateGutMicrobialMetabolism

    public java.util.ArrayList<Biotransformation> simulateGutMicrobialMetabolism​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                 boolean preprocess,
                                                                                 boolean filter,
                                                                                 int numberOfSteps)
                                                                          throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateGutMicrobialMetabolism

    public java.util.ArrayList<Biotransformation> simulateGutMicrobialMetabolism​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                 boolean preprocess,
                                                                                 boolean filter,
                                                                                 int numberOfSteps,
                                                                                 java.lang.Double scoreThreshold)
                                                                          throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateGutMicrobialMetabolism

    public java.util.ArrayList<Biotransformation> simulateGutMicrobialMetabolism​(org.openscience.cdk.interfaces.IAtomContainerSet targets,
                                                                                 boolean preprocess,
                                                                                 boolean filter,
                                                                                 int numberOfSteps)
                                                                          throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateGutMicrobialMetabolism

    public java.util.ArrayList<Biotransformation> simulateGutMicrobialMetabolism​(org.openscience.cdk.interfaces.IAtomContainerSet targets,
                                                                                 boolean preprocess,
                                                                                 boolean filter,
                                                                                 int numberOfSteps,
                                                                                 java.lang.Double scoreThreshold)
                                                                          throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateGutMicrobialMetabolism

    public java.util.ArrayList<Biotransformation> simulateGutMicrobialMetabolism​(java.lang.String targetsFileNameInSDF,
                                                                                 boolean preprocess,
                                                                                 boolean filter,
                                                                                 int nr_of_steps,
                                                                                 java.lang.Double scoreThreshold)
                                                                          throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateGutMicrobialMetabolismAndSave

    public void simulateGutMicrobialMetabolismAndSave​(java.lang.String targetsFileNameInSDF,
                                                      boolean preprocess,
                                                      boolean filter,
                                                      int nr_of_steps,
                                                      java.lang.Double scoreThreshold,
                                                      java.lang.String metabolitesFileNameInSDF)
                                               throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateGutMicrobialMetabolismAndSave

    public void simulateGutMicrobialMetabolismAndSave​(java.lang.String targetsFileNameInSDF,
                                                      boolean preprocess,
                                                      boolean filter,
                                                      int nr_of_steps,
                                                      java.lang.Double scoreThreshold,
                                                      java.lang.String metabolitesFileNameInSDF,
                                                      boolean annotate)
                                               throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateGutMicrobialMetabolismAndSaveToSDF

    public void simulateGutMicrobialMetabolismAndSaveToSDF​(org.openscience.cdk.interfaces.IAtomContainerSet containers,
                                                           int nrOfSteps,
                                                           java.lang.Double scoreThreshold,
                                                           java.lang.String outputFolder)
                                                    throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### simulateGutMicrobialMetabolismAndSaveToSDF

    public void simulateGutMicrobialMetabolismAndSaveToSDF​(org.openscience.cdk.interfaces.IAtomContainerSet containers,
                                                           int nrOfSteps,
                                                           java.lang.Double scoreThreshold,
                                                           java.lang.String outputFolder,
                                                           boolean annotate)
                                                    throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### isDeconjugationCandidate

    public boolean isDeconjugationCandidate​(org.openscience.cdk.interfaces.IAtomContainer molecule)
                                     throws ambit2.smarts.query.SMARTSException,
                                            org.openscience.cdk.exception.CDKException,
                                            java.io.IOException

Throws:
  `ambit2.smarts.query.SMARTSException`
  `org.openscience.cdk.exception.CDKException`
  `java.io.IOException`

#### isConjugationCandidate

    public boolean isConjugationCandidate​(org.openscience.cdk.interfaces.IAtomContainer molecule)
                                   throws ambit2.smarts.query.SMARTSException,
                                          org.openscience.cdk.exception.CDKException,
                                          java.io.IOException

Throws:
  `ambit2.smarts.query.SMARTSException`
  `org.openscience.cdk.exception.CDKException`
  `java.io.IOException`

#### printStatistics

    public void printStatistics()